/* @ropendir.c - open directories recursively
 */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>
#include <errno.h>
#include <pwd.h>
#include <grp.h>
#include "gen.h"
#include "ropendir.h"
#ifndef STANDARD
#include "zstand.h"
#endif

/* -@ropendir
 */
Rdir *ropendir(char *path, int options)
	{
	Rdir *rtn = NULL;
	char real[PATHSIZE+1];
	DIR *dir;

	if ((dir = opendir(path)) == NULL)
		;
	else if ((rtn = (Rdir *)malloc(sizeof(Rdir))) == NULL)
		errno = -(errno = ENOMEM);
	else if ((rtn->path = (char *)malloc(PATHSIZE+1)) == NULL)
		errno = -(errno = ENOMEM);
	else
		{
		rtn->options = options;
		rtn->arraysize = MAXDEPTH;
		rtn->numdirs = 1;
		rtn->dirs[0] = dir;
		readdir(dir);
		readdir(dir);
		strcpy(rtn->path, path);
		}
#	ifdef DEB
	errfmt("ropendir:beg path '%s'\n", path);
#	endif
	return rtn;
	}

/* -@rreaddir
 */
struct dirent *rreaddir(Rdir *dir)
	{
	struct dirent *rtn = NULL;
	char entpath[PATHSIZE+1];
	Stat sstat;

#	ifdef DEB
	errfmt("rreaddir '%s'\n", dir->path);
#	endif
	while (rtn == NULL)
		{
		if ((rtn = readdir(dir->dirs[dir->numdirs-1])) == NULL)
			{
			int len;
			closedir(dir->dirs[dir->numdirs-1]);
			dir->numdirs--;
			len = strlen(dir->path)-1;
			while (0 <= len)
				{
				if (dir->path[len] == '/')
					{
					dir->path[len] = EOS;
					break;
					}
				dir->path[len] = EOS;
				len--;
				}
#	ifdef DEB
	errfmt("Up a level '%s'\n", dir->path);
#	endif
			}
#	ifdef DEB
			else
				errfmt("Succefful read\n");
#	endif
		if (dir->numdirs == 0)
			break;
		}
	if (rtn != NULL)
		{
		cpystr(entpath, dir->path, dir->path[strlen(dir->path)-1] == '/' ? "" : "/", rtn->d_name, NULL);
		strcpy(rtn->d_name, entpath);
		if (0 <= stat(rtn->d_name, &sstat) && S_ISDIR(sstat.st_mode))
			{
			if ((dir->dirs[dir->numdirs] = opendir(rtn->d_name)) != NULL)
				{
#	ifdef DEB
	errfmt("Down a level0 '%s' '%s' %d ino %d\n", dir->path, rtn->d_name, sstat.st_mode, rtn->d_ino);
#	endif
				readdir(dir->dirs[dir->numdirs]);
				readdir(dir->dirs[dir->numdirs]);
				dir->numdirs++;
				strcpy(dir->path, rtn->d_name);
#	ifdef DEB
	errfmt("Down a level '%s' '%s' %d\n", dir->path, rtn->d_name, sstat.st_mode);
#	endif
				}
			}
		}
	return rtn;
	}

/* -@rclosedir
 */
int rclosedir(Rdir *dir)
	{
	int rtn;
	return rtn;
	}

/* -@rrewinddir
 */
void rrewinddir(Rdir *dir)
	{
	}

#if !defined(_POSIX_SOURCE)

/* -@rtelldir
 */
Seek rtelldir(Rdir *dir)
	{
	Seek rtn;

	return rtn;
	}

/* -@rseekdir
 */
void rseekdir(Rdir *dir, Seek seek)
	{
	}

#endif

#ifdef TEST
 int main(int argc, char **argv)
	{
	Rdir *dir;
	struct dirent *ent;
	dir = ropendir(argv[1], 0, 0);
	while ((ent = rreaddir(dir)) != NULL)
		errfmt("%s\n", ent->d_name);
	}
#endif
